[prev] [prev-tail] [tail] [up]

#### 6.9 Auxiliary Methods

Various functionalities are implemented as additional methods of the preconditioner object.

##### 6.9.1 Method: dump

call p%dump(info[,istart,iend,prefix,head,ac,rp,smoother,solver,global_num])

Dump on file.

Arguments

info | integer, intent(out).
| Error code. If no error, 0 is returned. See Section 8 for details.
amold | class(psb_x_base_sparse_mat), intent(in), optional.
| The desired dynamic type for internal matrix components; this allows e.g. running on GPUs; it needs not be the same on all processes. See the PSBLAS User’s Guide for details [13].

##### 6.9.2 Method: clone

call p%clone(pout,info)

Create a (deep) copy of the preconditioner object.

Arguments

pout | type(mld_x prec_type), intent(out).
| The copy of the preconditioner data structure. Note that x must be chosen according to the real/complex, single/double precision version of MLD2P4 under use.
info | integer, intent(out).
| Error code. If no error, 0 is returned. See Section 8 for details.

##### 6.9.3 Method: sizeof

sz = p%sizeof()

Return memory footprint in bytes.

##### 6.9.4 Method: allocate_wrk

call p%allocate_wrk(info[, vmold])

Allocate internal work vectors. Each application of the preconditioner uses a number of work vectors which are allocated internally as necessary; therefore allocation and deallocation of memory occurs multiple times during the execution of a Krylov method. In most cases this strategy is perfectly acceptable, but on some platforms, most notably GPUs, memory allocation is a slow operation, and the default behaviour would lead to a slowdown. This method allows to trade space for time by preallocating the internal workspace outside of the invocation of a Krylov method. When using GPUs or other specialized devices, the vmold argument is also necessary to ensure the internal work vectors are of the appropriate dynamic type to exploit the accelerator hardware; when allocation occurs internally this is taken care of based on the dynamic type of the x argument to the apply method.

Arguments

info | integer, intent(out).
| Error code. If no error, 0 is returned. See Section 8 for details.
vmold | class(psb_x_base_vect_type), intent(in), optional.
| The desired dynamic type for internal vector components; this allows e.g. running on GPUs.

##### 6.9.5 Method: free_wrk

call p%free_wrk(info)

Deallocate internal work vectors.

Arguments

info | integer, intent(out).
| Error code. If no error, 0 is returned. See Section 8 for details.

[prev] [prev-tail] [front] [up]